package jalview.io;

import jalview.gui.*;
import jalview.datamodel.*;
import jalview.schemes.*;
import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;


public class HTMLOutput
{
  SequenceRenderer sr = new SequenceRenderer();

  public HTMLOutput(AlignmentI alignment, ColourSchemeI cs)
  {
    Color color;
    JFileChooser chooser = new JFileChooser(jalview.bin.Cache.LAST_DIRECTORY);
    chooser.setDialogTitle("Save as HTML");
    chooser.setToolTipText("Save");
    int value = chooser.showSaveDialog(null);
    if(value == JFileChooser.APPROVE_OPTION)
    {
      String choice =  chooser.getSelectedFile().getPath();
      jalview.bin.Cache.LAST_DIRECTORY = choice;
      try{
        PrintWriter out = new java.io.PrintWriter(new java.io.FileWriter(choice));
        out.println("<HTML>");
        out.println("<style type=\"text/css\">");
        out.println("<!--");
        out.println("td {font-family: \"Courier New\", Courier, mono; font-size: medium;}");
        out.println("-->");
        out.println("</style>");
        out.println("<BODY>");
        out.println("<table border=\"1\"><tr><td>\n");
        out.println("<table border=\"0\"  cellpadding=\"0\" cellspacing=\"0\">\n");


        //////////////
        for (int i = 0; i < alignment.getHeight(); i++)
        {
          SequenceI seq = alignment.getSequenceAt(i);
          out.println("<tr><td>"+seq.getName()+"&nbsp;&nbsp;</td>");
          for (int res = 0; res < seq.getLength(); res++)
          {
            color = sr.getResidueBoxColour(cs, seq, res);
            Integer.toHexString(color.getRed());

            out.println("<td bgcolor=\"#"
                        + Integer.toHexString(color.getRed())
                        + Integer.toHexString(color.getGreen())
                        + Integer.toHexString(color.getBlue())
                        +"\"><center>"+seq.getCharAt(res)+"</center></td>");
          }

          out.println("</tr>");
        }
        //////////////
        out.println("</td></tr></table>");
        out.println("</table>\n</body>\n</html>");

        out.close();
      }
      catch(Exception ex){}
    }
  }


}
